;##################################################################
; ATL DEMO APP
;##################################################################

#include "ATLDemo.h"


DEBUGLIB equ \Programming\RadASM\GoAsm\lib\Debug.lib
DEBUGEXE equ "\Programming\RadAsm\GoAsm\lib\dbgwin.exe"

#include "\Programming\RadASM\GoAsm\inc\debug.a"
DBGWIN_DEBUG_ON = 1 // use this to enable Spy/StopSpy/DbgDump and TrapException
DBGWIN_SHOWONLYERRORS = 1 // setting this to 1 will suppress PrintError if no error exists 

COMObject  STRUCT
	; interface object
	lpVtbl			DD		0
	; object data
	nRefCount		DD		1
ENDS

// Custom messages
WBN_BEFORENAVIGATE equ WM_USER + DISPID_BEFORENAVIGATE
WBN_BEFORENAVIGATE2 equ WM_USER + DISPID_BEFORENAVIGATE2
WBN_NAVIGATECOMPLETE equ WM_USER + DISPID_NAVIGATECOMPLETE
WBN_STATUSTEXTCHANGE equ WM_USER + DISPID_STATUSTEXTCHANGE
WBN_QUIT equ WM_USER + DISPID_QUIT
WBN_DOWNLOADCOMPLETE equ WM_USER + DISPID_DOWNLOADCOMPLETE
WBN_COMMANDSTATECHANGE equ WM_USER + DISPID_COMMANDSTATECHANGE
WBN_DOWNLOADBEGIN equ WM_USER + DISPID_DOWNLOADBEGIN
WBN_NEWWINDOW equ WM_USER + DISPID_NEWWINDOW
WBN_PROGRESSCHANGE equ WM_USER + DISPID_PROGRESSCHANGE
WBN_WINDOWMOVE equ WM_USER + DISPID_WINDOWMOVE
WBN_WINDOWRESIZE equ WM_USER + DISPID_WINDOWRESIZE
WBN_WINDOWACTIVATE equ WM_USER + DISPID_WINDOWACTIVATE
WBN_PROPERTYCHANGE equ WM_USER + DISPID_PROPERTYCHANGE
WBN_TITLECHANGE equ WM_USER + DISPID_TITLECHANGE
WBN_TITLEICONCHANGE equ WM_USER + DISPID_TITLEICONCHANGE
WBN_NEWWINDOW3 equ WM_USER + DISPID_NEWWINDOW3

CMD_OK equ 1
CMD_PREV equ WM_USER
CMD_NEXT equ WM_USER + 1
CMD_REFRESH equ WM_USER + 2
CMD_BROWSE equ WM_USER + 3
CMD_HOME equ WM_USER + 4
CMD_STOP equ WM_USER + 5

#define IDR_TBBITMAP 16
#define IDR_ICON 1
CONSTANT SECTION
	IID_IWebBrowser2	GUID	GUID_IID_IWebBrowser2
	IID_DWebBrowserEvents2 GUID GUID_IID_DWebBrowserEvents2

DATA SECTION
	// USER32 handles
	hInstance			DD 		?
	hDlg				DD		?
	hAtl				DD		?
	hToolBar			DD		?
	hRebar				DD		?
	hProgBar			DD		?
	hStatus				DD		?
	hUrlbox				DD		?
	hImlSmall			DD		?

	// Status bar stuff
	StatHeight			DD		?
	sbparts				DD		200
						DD		-1

	// Interface pointers
	pIUnknown			DD		?
	pIWebBrowser2		DD		?

	url					DB		1024 DUP (?)

	// AtlAdvise cookie
	dwCookie			DD	0

	// Our DWebBrowserEvents2 interface
	objEventSync		COMObject	<offset vtblEventSync,1>
	vtblEventSync		DD DWebBrowserEvents2_QueryInterface
						DD DWebBrowserEvents2_AddRef
						DD DWebBrowserEvents2_Release
						DD DWebBrowserEvents2_GetTypeInfoCount
						DD DWebBrowserEvents2_GetTypeInfo
						DD DWebBrowserEvents2_GetIDsOfNames
						DD DWebBrowserEvents2_Invoke

	// Class name for the dialog
	ClassName			DB		"DialogClass",0

	ALIGN 16
	tbrbtns				TBBUTTON	<0,CMD_PREV,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0,0>
						TBBUTTON	<1,CMD_NEXT,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0,0>
						TBBUTTON	<2,CMD_STOP,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0,0>
						TBBUTTON	<3,CMD_REFRESH,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0,0>
						TBBUTTON	<4,CMD_HOME,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0,0>

	tbbend:
	nToolbarBtns		equ	(tbbend-tbrbtns) /SIZEOF TBBUTTON

CODE SECTION

Start:
	invoke GetModuleHandle, 0
	mov [hInstance],eax
	invoke CoInitialize,NULL
	invoke InitCommonControls
	invoke WinMain,[hInstance],NULL,NULL,SW_SHOW
	invoke CoUninitialize
	invoke ExitProcess,0

WinMain FRAME hInst,hPrevInstance,lpCmdLine,nCmdShow
	LOCAL	wc				:WNDCLASSEX
	LOCAL	msg				:MSG
	LOCAL	hdc				:D
	LOCAL	rect			:RECT
	LOCAL	rbbi			:REBARBANDINFO

	// Define our main window class and register it
	mov		D[wc.cbSize], SIZEOF WNDCLASSEX
	mov		D[wc.style], CS_HREDRAW + CS_VREDRAW
	mov		D[wc.lpfnWndProc], OFFSET DlgProc
	mov		D[wc.cbClsExtra], NULL
	mov		D[wc.cbWndExtra], DLGWINDOWEXTRA
	mov		eax, [hInstance]
	mov		D[wc.hInstance], eax
	mov		D[wc.hbrBackground], COLOR_BTNFACE + 1
	mov		D[wc.lpszMenuName], NULL
	mov		D[wc.lpszClassName], OFFSET ClassName
	invoke	LoadIcon, NULL, IDI_APPLICATION
	mov		D[wc.hIcon], eax
	mov		D[wc.hIconSm], eax
	invoke	LoadCursor,NULL,IDC_ARROW
	mov		D[wc.hCursor], eax

	invoke	RegisterClassEx, addr wc
	or eax,eax
	jnz >
		// If we were unable to register the class shut down
		invoke	ExitProcess, -1
	:

	// Create our dialog
	invoke	CreateDialogParam, [hInstance],1000, NULL, NULL, NULL
	or eax,eax
	jnz >
		// If we were unable to create the dialog shut down
		invoke	ExitProcess, -1
	:
	mov [hDlg],eax

	// Initialize the Active Template Library classes
	invoke AtlAxWinInit

	// Get the handle of the REBAR control
	invoke GetDlgItem,[hDlg],1001
	mov [hRebar],eax

	// Get the handle of the toolbar
	invoke GetDlgItem,[hDlg],1002
	mov [hToolBar],eax

	// Set up the toolbar
	call SetupToolbar

	// Set up the REBAR control
	// Add the toolbar to the rebar
	mov D[rbbi.cbSize],SIZEOF REBARBANDINFO
	mov D[rbbi.fMask],RBBIM_CHILD or RBBIM_ID or RBBIM_SIZE or RBBIM_CHILDSIZE or RBBIM_STYLE
	mov eax,[hToolBar]
	mov [rbbi.hwndChild],eax
	mov D[rbbi.fStyle],RBBS_TOPALIGN + RBBS_GRIPPERALWAYS
	mov D[rbbi.clrFore],00FFFFFFh
	mov D[rbbi.clrBack],0
	mov D[rbbi.cx],128
	mov D[rbbi.cxMinChild],16
	mov D[rbbi.cyMinChild],24
	mov D[rbbi.cxIdeal],128
	mov D[rbbi.wID],40001
	invoke SendMessage,[hRebar],RB_INSERTBAND,0,offset rbbi

	// Get the handle of the URL textbox
	invoke GetDlgItem,[hDlg],1003
	mov [hUrlbox],eax

	// Add the URL textbox to the rebar
	mov eax,[hUrlbox]
	mov [rbbi.hwndChild],eax
	mov D[rbbi.cx],16
	mov D[rbbi.cxMinChild],16
	mov D[rbbi.cyMinChild],24
	mov D[rbbi.cxIdeal],16
	mov D[rbbi.wID],40002
	invoke SendMessage,[hRebar],RB_INSERTBAND,1,offset rbbi

	// Force the rebar to redraw
	invoke RedrawWindow,[hRebar],NULL,NULL,TRUE

	// Get the handle of the status bar
	invoke GetDlgItem,[hDlg],1005
	mov [hStatus],eax

	// Precalculate the height of the status bar
	// this will save from calculating it each time
	// the window is resized
	invoke GetWindowRect,[hStatus],offset rect
	mov eax,[rect.bottom]
	sub eax,[rect.top]
	mov [StatHeight],eax

	// Divide the status bar into 2 parts
	invoke SendMessage,[hStatus],SB_SETPARTS,2,offset sbparts

	// Get the bounding rectanlge of the status bars first section
	invoke SendMessage,[hStatus],SB_GETRECT,0,offset rect

	// Create a progress bar inside the status bars first part
	invoke CreateWindowEx,NULL,PROGRESS_CLASS,NULL,WS_CHILD+WS_VISIBLE, \
		[rect.left],[rect.top],[rect.right],[rect.bottom],[hStatus],1004, \
		[hInstance],NULL
	mov [hProgBar],eax

	// Set the range of the progress bar, since progress is calculated as
	// a percentage, set it to a range of 0 to 100
	invoke SendMessage,[hProgBar],PBM_SETRANGE32,0,100

	// Calculate the rough bounding rectangle of our WebBrowser window
	invoke SendMessage,[hRebar],RB_GETBARHEIGHT,0,0
	add eax, 4
	push eax
	invoke GetClientRect,[hDlg],offset rect
	pop eax
	mov [rect.top],eax
	add eax,[StatHeight]
	sub D[rect.bottom],eax

	// Create the WebBrowser window
	invoke CreateWindowEx,WS_EX_STATICEDGE,"AtlAxWin","about:blank",WS_CHILD + WS_VISIBLE +WS_VSCROLL,[rect.left],[rect.top],[rect.right],[rect.bottom],[hDlg],1001,[hInstance],NULL
	mov [hAtl],eax

	// Get a pointer to the WebBrowser's IUnknown interface
	invoke AtlAxGetControl, [hAtl],offset pIUnknown
	// Query the WebBrowser for a pointer to its IWebBrowser2 interface
	CoInvoke(pIUnknown,IWebBrowser2.IUnknown.QueryInterface,offset IID_IWebBrowser2,offset pIWebBrowser2)

	// We'll do our own controls, it makes the event sink a little more manageable
	CoInvoke(pIWebBrowser2,IWebBrowser2.put_AddressBar,VARIANT_FALSE)
	CoInvoke(pIWebBrowser2,IWebBrowser2.put_MenuBar,VARIANT_FALSE)
	CoInvoke(pIWebBrowser2,IWebBrowser2.put_ToolBar,VARIANT_FALSE)

	// Resize the control to its final size
	invoke SetWindowPos,[hAtl],NULL,[rect.left],[rect.top],[rect.right],[rect.bottom],SWP_NOMOVE + SWP_NOZORDER

	// Resize the rebar control to its final size
	invoke SendMessage,[hRebar],RB_GETBARHEIGHT,0,0
	invoke SetWindowPos,[hRebar],NULL,0,0,[rect.right],eax,SWP_NOMOVE + SWP_NOZORDER

	// Set the Event Sink
	invoke AtlAdvise,[pIWebBrowser2],offset objEventSync,offset IID_DWebBrowserEvents2,offset dwCookie

	// Load the start page
	invoke GoToURL,[pIWebBrowser2],"http://www.masm32.com/board/index.php?board=8.0"

	// Set the icon for our main dialog
	invoke LoadIcon,[hInstance],1
	invoke SendMessage,[hDlg],WM_SETICON,ICON_SMALL,eax

	// Show the dialog
	invoke ShowWindow,[hDlg],[nCmdShow]

	// Message pump
	:
		invoke GetMessage, ADDR msg,NULL,0,0
		or eax,eax
		jz >
			invoke IsDialogMessage, [hDlg], ADDR msg
			or eax,eax
			jnz <
				invoke TranslateMessage, ADDR msg
				invoke DispatchMessage, ADDR msg
				jmp <
	:

	mov eax,[msg.wParam]

	ret
ENDF

DlgProc FRAME hwnd,uMsg,wParam,lParam
	LOCAL rect	:RECT

	cmp D[uMsg],WM_CREATE
	jne >.WM_COMMAND
		// Nothing happening here
		jmp >>.EXIT

	.WM_COMMAND
	cmp D[uMsg],WM_COMMAND
	jne >>.WBN_BEFORENAVIGATE2
		// Process the toolbar buttons
		movzx eax,W[wParam]
		cmp eax,CMD_PREV
		jne >>
			invoke GoBack,[pIWebBrowser2]
			jmp >>.EXIT
		:
		cmp eax,CMD_NEXT
		jne >>
			invoke GoForward,[pIWebBrowser2]
			jmp >>.EXIT
		:
		cmp eax,CMD_REFRESH
		jne >>
			invoke Refresh,[pIWebBrowser2]
			jmp >>.EXIT
		:
		cmp eax,CMD_HOME
		jne >>
			invoke GoToURL,[pIWebBrowser2],"http://www.masm32.com/board/index.php?board=8.0"
			jmp >>.EXIT
		:
		cmp eax,CMD_STOP
		jne >>
			invoke Stop,[pIWebBrowser2]
			jmp >>.EXIT
		:
		// This is sent if the user presses enter
		// Check to see if enter was pressed while inside the URL textbox
		cmp eax,CMD_OK
		jne >>
			invoke GetFocus
			cmp eax, [hUrlbox]
			jne >>.EXIT
			invoke SendMessage,[hUrlbox],WM_GETTEXT,1024,offset url
			invoke lstrlen,offset url
			test eax,eax
			jz >>.EXIT
			invoke GoToURL,[pIWebBrowser2],offset url
		:
		jmp >>.EXIT

	.WBN_BEFORENAVIGATE2
	cmp D[uMsg],WBN_BEFORENAVIGATE2
	jne >>.WBN_NAVIGATECOMPLETE
		invoke SendMessage,[hStatus],SB_SETTEXT,1,"Page loading..."
		ret

	.WBN_NAVIGATECOMPLETE
	cmp D[uMsg],WBN_NAVIGATECOMPLETE
	jne >>.WBN_DOWNLOADCOMPLETE
		invoke SendMessage,[hStatus],SB_SETTEXT,1,"done"
		// The page has finished loading
		// Get the name of the page and display it in the titlebar
		invoke GetName,[pIWebBrowser2],offset url
		invoke lstrcat, offset url, " - GoAsm ATL demo"
		invoke SetWindowText,[hwnd],offset url
		// Get the URL and display it in the URL textbox
		invoke GetURL,[pIWebBrowser2],offset url
		invoke SetWindowText,[hUrlbox],offset url
		ret

	.WBN_DOWNLOADCOMPLETE
	cmp D[uMsg],WBN_DOWNLOADCOMPLETE
	jne >>.WBN_QUIT
		invoke SendMessage,[hStatus],SB_SETTEXT,1,"done"
		// The page has finished loading
		// Get the name of the page and display it in the titlebar
		invoke GetName,[pIWebBrowser2],offset url
		invoke lstrcat, offset url, " - GoAsm ATL demo"
		invoke SetWindowText,[hwnd],offset url
		// Get the URL and display it in the URL textbox
		invoke GetURL,[pIWebBrowser2],offset url
		invoke SetWindowText,[hUrlbox],offset url
		ret

	.WBN_QUIT
	cmp D[uMsg],WBN_QUIT
	jne >>.WM_SIZE
		// The WebBrowser is shutting down so shut down the application as well
		invoke PostMessage,[hwnd],WM_CLOSE,0,0
		jmp >>.DEFPROC

	.WM_SIZE
	cmp D[uMsg],WM_SIZE
	jne >>.WM_DESTROY
		cmp D[pIWebBrowser2], 0
		je >>.EXIT
		// The dialog has been resized, recalculate and set all of its components sizes
		invoke SendMessage,[hRebar],RB_GETBARHEIGHT,0,0
		add eax,4
		push eax
		invoke GetClientRect,[hDlg],offset rect
		pop eax
		mov [rect.top],eax
		add eax,[StatHeight]
		sub D[rect.bottom],eax
		invoke SetWindowPos,[hAtl],NULL,[rect.left],[rect.top],[rect.right],[rect.bottom],SWP_NOMOVE + SWP_NOZORDER

		invoke SendMessage,[hRebar],RB_GETBARHEIGHT,0,0
		invoke SetWindowPos,[hRebar],NULL,0,0,[rect.right],eax,SWP_NOMOVE + SWP_NOZORDER

		// Set the statusbar position
		invoke GetClientRect,[hwnd],offset rect
		mov eax,[rect.bottom]
		sub eax,[StatHeight]
		mov [rect.top],eax
		invoke SetWindowPos,[hStatus],NULL,0,[rect.top],[rect.right],[rect.bottom],SWP_NOZORDER
		jmp >>.EXIT

	.WM_DESTROY
	cmp D[uMsg],WM_DESTROY
	jne >.DEFPROC
		// The application is shutting down so reset the event sink and release the WebBrowser
		invoke AtlUnadvise,[pIWebBrowser2],offset IID_DWebBrowserEvents2,[dwCookie]
		CoInvoke(pIUnknown,IWebBrowser2.IUnknown.Release)
		CoInvoke(pIWebBrowser2,IWebBrowser2.IUnknown.Release)
		// Quit
		invoke PostQuitMessage,0

	.DEFPROC
		invoke DefWindowProc,[hwnd],[uMsg],[wParam],[lParam]
		ret

	.EXIT

	xor eax,eax
	ret

ENDF

SetupToolbar:
	// Load the image list
	invoke ImageList_LoadImage,[hInstance],IDR_TBBITMAP,16,16,0,IMAGE_BITMAP,LR_CREATEDIBSECTION
	mov [hImlSmall],eax
	// Set the background color to black
	invoke ImageList_SetBkColor,[hImlSmall],CLR_NONE
	// Assign the image list to the toolbar
	invoke SendMessage,[hToolBar],TB_SETIMAGELIST,0,[hImlSmall]
	// Indent the buttons by 8 pixels
	invoke SendMessage,[hToolBar],TB_SETINDENT,8,0
	// Add the toolbar buttons
	invoke SendMessage,[hToolBar],TB_BUTTONSTRUCTSIZE,sizeof TBBUTTON,0
	invoke SendMessage,[hToolBar],TB_ADDBUTTONS,nToolbarBtns,OFFSET tbrbtns
	// Reset the toolbar size
	invoke SendMessage,[hToolBar],TB_AUTOSIZE,0,0
	RET

Stop FRAME pInterface
	
	CoInvoke(pInterface,IWebBrowser2.Stop)
	RET
ENDF

GoBack FRAME pInterface
	
	CoInvoke(pInterface,IWebBrowser2.GoBack)
	RET
ENDF

Refresh FRAME pInterface
	
	CoInvoke(pInterface,IWebBrowser2.Refresh)
	RET
ENDF

GoForward FRAME pInterface
	
	CoInvoke(pInterface,IWebBrowser2.GoForward)
	RET
ENDF

GoHome FRAME pInterface
	
	CoInvoke(pInterface,IWebBrowser2.GoHome)
	RET
ENDF

GetURL FRAME pInterface, pszURL
	LOCAL pbstrURL:D
	invoke SysAllocStringLen ,NULL,1024
	mov [pbstrURL],eax

	CoInvoke(pInterface,IWebBrowser2.get_LocationURL,[pbstrURL])

	// Convert the url to ANSI
	mov eax,[pbstrURL]
	mov eax,[eax]
	invoke WideCharToMultiByte,CP_ACP,NULL,eax,-1,[pszURL],1024,"",NULL
	push eax
	invoke SysFreeString,[pbstrURL]
	pop eax
	RET
ENDF

GetName FRAME pInterface, pszName
	LOCAL pbstrName:D
	invoke SysAllocStringLen ,NULL,1024
	mov [pbstrName],eax

	CoInvoke(pInterface,IWebBrowser2.get_LocationName,[pbstrName])

	// Convert the url to ANSI
	mov eax,[pbstrName]
	mov eax,[eax]
	invoke WideCharToMultiByte,CP_ACP,NULL,eax,-1,[pszName],1024,"",NULL
	push eax
	invoke SysFreeString,[pbstrName]
	pop eax
	RET
ENDF

GoToURL FRAME pInterface, pszURL
	LOCAL wszURL[1024]:W
	LOCAL pbstrURL:D
	LOCAL flags:VARIANT

	mov W[flags.vt], VT_I2
	mov W[flags.iVal], navNoHistory
	// Convert the url to unicode then create a BSTR with it
	invoke MultiByteToWideChar,CP_ACP,NULL,[pszURL],-1,offset wszURL,1024
	invoke SysAllocString,offset wszURL
	mov [pbstrURL],eax
	//_self
	CoInvoke(pInterface,IWebBrowser2.Navigate,[pbstrURL],offset flags,L"_self",NULL,NULL)
	push eax
	invoke SysFreeString,[pbstrURL]
	pop eax
	RET
ENDF

// Event Sync

// IUnknown Implementation

DWebBrowserEvents2_QueryInterface FRAME  this, riid, ppv

	mov eax,[ppv]
	mov D[eax], 0

	invoke IsEqualGUID, [riid], offset IID_DWebBrowserEvents2
	test eax,eax
	jz >
		mov eax, [this]
		mov edx, [ppv]
		mov [edx],eax
		mov eax, NOERROR
		RET
	:
	mov eax,E_NOINTERFACE
	ret

ENDF

DWebBrowserEvents2_AddRef FRAME this
	mov eax,[this]
	inc D[eax+COMObject.nRefCount]
	mov eax,[eax+COMObject.nRefCount]
	mov eax,1
	ret
ENDF

DWebBrowserEvents2_Release FRAME this
	mov eax,[this]
	dec D[eax+COMObject.nRefCount]
	js >.SIGNED
	jnz >
		.SIGNED
		mov D[eax+COMObject.nRefCount],0
		xor eax,eax
		ret
	:
	mov eax,[eax+COMObject.nRefCount]

	ret
ENDF

// IDispatch Implementation

DWebBrowserEvents2_GetIDsOfNames FRAME this, riid, rgszNames,  cNames,  lcid, rgDispId
	invoke DispGetIDsOfNames,[this], [rgszNames], [cNames], [rgDispId]
	ret
ENDF

DWebBrowserEvents2_Invoke FRAME this, dispIdMember, riid, lcid, wFlags, pdispparams, pVarResult, pExcepInfo, puArgErr
	uses edi,esi,ebx
	LOCAL exinfo:D
	LOCAL varResult:VARIANT
	LOCAL pBSTR:D
	LOCAL iFlags:D

	mov eax,[dispIdMember]
	cmp eax,DISPID_DOWNLOADCOMPLETE
	jne >
		invoke SendMessage, [hDlg],WBN_DOWNLOADCOMPLETE,0,[pdispparams]
		jmp >>.EXIT
	:
	cmp eax,DISPID_NAVIGATECOMPLETE
	jne >
		invoke SendMessage, [hDlg],WBN_NAVIGATECOMPLETE,0,[pdispparams]
		jmp >>.EXIT
	:
	cmp eax,DISPID_QUIT
	jne >
		invoke SendMessage, [hDlg],WBN_QUIT,0,[pdispparams]
		jmp >>.EXIT
	:
	cmp eax,DISPID_PROGRESSCHANGE
	jne >>
		mov edi,[pdispparams]
		mov eax,[edi+DISPPARAMS.cNamedArgs]
		test eax,eax
		jnz >>.EXIT
			// There are no named arguments in the VARIANTRG
			mov eax,[edi+DISPPARAMS.cArgs]
			test eax,eax
			jz >>.EXIT
			// Set up our VARIANT
			mov W[varResult.vt],VT_INT
			invoke DispGetParam,[pdispparams],1,VT_INT,offset varResult,offset exinfo
			// Get the max progress
			mov eax,offset varResult
			add eax,8
			mov edi,[eax]
			test edi,edi
			jz >>.NOPROG
			js >>.NOPROG

			// Set up our VARIANT
			mov W[varResult.vt],VT_INT
			invoke DispGetParam,[pdispparams],0,VT_INT,offset varResult,offset exinfo
			// Get the progress count
			mov eax,offset varResult
			add eax,8
			mov eax,[eax]

			test eax,eax
			js >>.NOPROG
			jz >>.NOPROG

			// Calculate the percentage complete
			mov ecx,100
			mul ecx
			xor edx,edx
			div edi
		
			invoke SendMessage,[hProgBar],PBM_SETPOS,eax,0
			jmp >>.EXIT
			.NOPROG
			invoke SendMessage,[hProgBar],PBM_SETPOS,0,0
			jmp >>.EXIT
	:
	cmp eax,DISPID_BEFORENAVIGATE2
	jne >>
		invoke SendMessage,[hDlg],WBN_BEFORENAVIGATE2,0,0
		jmp >>.EXIT
	:
	.EXIT
	mov eax,S_OK
	ret
ENDF

DWebBrowserEvents2_GetTypeInfo FRAME this, iTInfo, lcid, ppTInfo
	mov eax,E_NOTIMPL
	ret
ENDF

DWebBrowserEvents2_GetTypeInfoCount FRAME this, pctinfo
	mov eax,E_NOTIMPL
	ret
ENDF
